package Package1;

public class AbsoluteDurations {

    public static void main(String[] args) {

        if (args.length < 2) {
            System.out.println("E' necessario immettere almeno due argomenti");
            System.exit(1);
        }

        int bpm = -1;
        float value = -1;
        try {
            bpm = Integer.parseInt(args[0]);
            value = Float.parseFloat(args[1]);
        } catch (NumberFormatException e) {
            System.out.println("Il primo parametro (metronomo al quarto) deve essere compreso tra 40 e 208");
            System.out.println("Il secondo parametro (durata in secondi del valore ritmico) non e' corretto");
            System.exit(1);
        }

        String result = "Il valore ritmico e' costituito da ";
        float semibreveDuration = 60f / bpm * 4; // Durata della nota da 1/1

        int currentNoteDen = 1; // Denominatore della singola nota da processare
        while (currentNoteDen <= 128) { // Si arriva a 1/128
            int counter = 0;
            while (value >= semibreveDuration / currentNoteDen) {
                value = value - (semibreveDuration / currentNoteDen); // Si sottrae il valore della nota di tipo corrente...
                counter++;  // ...contando le sottrazioni
            }
            if (counter > 0)
                result += counter + " nota/e da 1/" + currentNoteDen + ", ";
            currentNoteDen *= 2; // Si passa alla figura ritmica successiva
        }
        result = result.substring(0, result.length() - 2); // Si elimina l'ultima virgola
        System.out.println(result);
    }

}
