package Package1;


import javax.swing.JOptionPane;

public class CbrStatsSwing extends javax.swing.JFrame {

    /**
     * Creates new form CbrStatsSwing
     */
    public CbrStatsSwing() {
        initComponents();
    }
    
    int decodePc(int currentPitch) {
        return ((currentPitch % 1000) / 10);
    }

    int decodeOctave(int currentPitch) {
        return currentPitch / 1000;
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jTextFieldCBRs = new javax.swing.JTextField();
        jLabel1 = new javax.swing.JLabel();
        jButtonStats = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        jLabel3 = new javax.swing.JLabel();
        jLabel4 = new javax.swing.JLabel();
        jLabelFreqMean = new javax.swing.JLabel();
        jLabelLowerPitch = new javax.swing.JLabel();
        jLabelHighestPitch = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Statistiche CBR");

        jLabel1.setText("Note in codifica CBR (separate da spazi):");

        jButtonStats.setText("Calcola");
        jButtonStats.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonStatsActionPerformed(evt);
            }
        });

        jLabel2.setText("Pitch più acuto:");

        jLabel3.setText("Pitch più grave:");

        jLabel4.setText("Media delle frequenze:");

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jLabel1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jTextFieldCBRs, javax.swing.GroupLayout.DEFAULT_SIZE, 210, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButtonStats)
                        .addContainerGap())
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel4)
                            .addComponent(jLabel3)
                            .addComponent(jLabel2))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabelHighestPitch)
                            .addComponent(jLabelLowerPitch)
                            .addComponent(jLabelFreqMean))
                        .addGap(0, 0, Short.MAX_VALUE))))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGap(8, 8, 8)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jTextFieldCBRs, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel1)
                    .addComponent(jButtonStats))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(jLabelHighestPitch))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(jLabelLowerPitch))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel4)
                    .addComponent(jLabelFreqMean))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButtonStatsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonStatsActionPerformed
        String[] cbrs = jTextFieldCBRs.getText().split(" ");
        int[] cbrSequence = new int[cbrs.length];
        try {
            for (int i = 0; i < cbrs.length; i++) {
                cbrSequence[i] = Integer.parseInt(cbrs[i]);
                // verifica sulla correttezza della codifica cbr in ingresso:
                //   nc                            pc
                if ((cbrSequence[i] % 10 > 6) || ((cbrSequence[i] % 1000) / 10) > 11) {
                    JOptionPane.showMessageDialog(this, "Valore immesso non valido nella codifica cbr: " + cbrSequence[i], "Errore", JOptionPane.ERROR_MESSAGE);
                    return;
                }
            }
        } catch (NumberFormatException e) {
            JOptionPane.showMessageDialog(this, "Gli argomenti devono essere di tipo intero", "Errore", JOptionPane.ERROR_MESSAGE);
            return;
        }

        double maxF = Float.MIN_VALUE;
        double minF = Float.MAX_VALUE;
        double sum = 0;

        double halftoneRatio = Math.pow(2, (double) 1 / 12); // radice dodicesima di due

        for (int currentPitch : cbrSequence) {
            // calcolo lo spiazzamento in semitoni dal La dell'ottava centrale (PC=9), cui corrisponde f = 440Hz
            int halftonesOffset = decodeOctave(currentPitch) * 12 + decodePc(currentPitch) - (12 * 4 + 9);
            double currentF = 440 * Math.pow(halftoneRatio, halftonesOffset);
            if (currentF > maxF)
                maxF = currentF;
            if (currentF < minF)
                minF = currentF;
            sum += currentF;
        }
        double averageF = sum / cbrSequence.length;
        jLabelHighestPitch.setText(String.format("%.2f", maxF) + "Hz");
        jLabelLowerPitch.setText(String.format("%.2f", minF) + "Hz");
        jLabelFreqMean.setText(String.format("%.2f", averageF) + "Hz");
    }//GEN-LAST:event_jButtonStatsActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels())
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(CbrStatsSwing.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(CbrStatsSwing.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(CbrStatsSwing.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(CbrStatsSwing.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new CbrStatsSwing().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonStats;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabelFreqMean;
    private javax.swing.JLabel jLabelHighestPitch;
    private javax.swing.JLabel jLabelLowerPitch;
    private javax.swing.JTextField jTextFieldCBRs;
    // End of variables declaration//GEN-END:variables
}
