package Package1;


import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.util.List;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.ScrollPaneConstants;
import javax.swing.SwingWorker;
import javax.swing.WindowConstants;

public class CountThread extends JFrame {

    JTextArea textArea;
    JButton button;
    SwingWorker<Void, Integer> worker;

    public CountThread(String title, int width, int height) {
        super(title);
        setLayout(new GridLayout(1, 2));
        textArea = new JTextArea(20, 30);
        textArea.setMaximumSize(new Dimension(width , height));
        JScrollPane scrollPane = new JScrollPane(textArea,
                ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS,
                ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);
        add(scrollPane);
        button = new JButton("Start");
        button.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(ActionEvent e) {
                if (button.getText().equals("Start")) {
                    worker.execute();
                    button.setText("Stop");
                } else
                    worker.cancel(true);
            }
        });
        add(button);
        setDefaultCloseOperation(WindowConstants.EXIT_ON_CLOSE);
        setSize(width, height);
        pack();
        setVisible(true);
        
        worker = new SwingWorker<Void, Integer>() {
            Integer count = 0;
            
            @Override
            public Void doInBackground() {
                while (!isCancelled()) {
                    publish(++count);
                    try {
                        Thread.sleep(10); // Blocca il thread per 1 secondo
                    } catch (InterruptedException ex) {
                    }
                }
                return null;
            }
            
            @Override
            protected void process(List<Integer> chunks) {
                textArea.append("In process\n");
                for (Integer i : chunks) {
                    textArea.append(String.valueOf(i) + "\n");
                }
            }
        };
        worker.addPropertyChangeListener(new PropertyChangeListener() {
            @Override
            public void propertyChange(final PropertyChangeEvent event) {
                if (event.getPropertyName().equals("state")) {
                    switch ((SwingWorker.StateValue) event.getNewValue()) {
                        case STARTED: // Prima dell’esecuzione di doInBackground
                            textArea.append("STARTED\n");
                            break;
                        case DONE: // Task concluso
                            textArea.append("DONE\n");
                            button.setText("Done");
                            button.setEnabled(false);
                            break;
                    }
                }
            }
        });
    }

    public static void main(String[] args) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            @Override
            public void run() {
                new CountThread("Statistiche IEEE 1599", 500, 400);
            }
        });
    }
}