package Package1;

public class CpcInversionRetro {

    public static int[] invert(int[] notes, int refPitch) {
        int[] result = new int[notes.length];
        for (int i = 0; i < notes.length; i++)
            result[i] = refPitch - (notes[i] - refPitch); // la formula è analoga a (2 * refPitch - currentPitch)
        return result;
    }
    
    public static int[] retro(int[] notes) {
        int[] result = new int[notes.length];
        for (int i = 0; i < notes.length / 2 + 1; i++) {
            result[i] = notes[notes.length - i - 1];
            result[notes.length - i - 1] = notes[i];
        }
        return result;
    }
    
    public static void main(String[] args) {
        if (args.length < 2) {
            System.out.println("Numero di argomenti errato: sono richiesti almeno 2 argomenti");
            System.exit(1);
        }
        int refPitch = -1;
        try {
            refPitch = Integer.parseInt(args[0]);
        } catch (NumberFormatException e) {
            System.out.println("L'argomento " + args[0] + " non e' di tipo numerico intero");
            System.exit(1);
        }

        int[] notes = new int[args.length - 1];
        for (int i = 1; i < args.length; i++) {
            try {
                notes[i - 1] = Integer.parseInt(args[i]);
            } catch (NumberFormatException e) {
                System.out.println("L'argomento " + args[i] + " non e' di tipo numerico intero");
                System.exit(1);
            }
        }
        System.out.print("Sequenza invertita rispetto a " + refPitch + ": ");
        for (int note : invert(notes, refPitch))
            System.out.print(note + " ");
        System.out.println();

        System.out.print("Sequenza retrogradata: ");
        for (int note : retro(notes))
            System.out.print(note + " ");
        System.out.println();
    }
}
