package Package1;


import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

public class IntervalBuilder1 {

    public static void main(String[] args) {

        // apre lo standard input
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        char pitchLetter = '?';
        String pitchAccidental = null;
        int intervalGenericSize = 0;
        String intervalQualifier = null;

        // lettura del nome della nota base
        try {
            while (pitchLetter != 'A' && pitchLetter != 'B' && pitchLetter != 'C' && pitchLetter != 'D'
                && pitchLetter != 'E' && pitchLetter != 'F' && pitchLetter != 'G') {
                System.out.print("Inserisci il nome della nota [A..G]: ");
                pitchLetter = br.readLine().toUpperCase().charAt(0);
            }
        } catch (IOException ioe) {
            System.out.println("IO error");
            System.exit(1);
        }

        // lettura dello stato di alterazione della nota base
        try {
            while (!"b".equals(pitchAccidental)
                    && !"#".equals(pitchAccidental) && !"bb".equals(pitchAccidental)
                    && !"x".equals(pitchAccidental) && !"".equals(pitchAccidental)) {
                System.out.print("Inserisci l'eventuale alterazione [bb, b, #, x]: ");
                pitchAccidental = br.readLine().toLowerCase();
            }
        } catch (IOException ioe) {
            System.out.println("IO error");
            System.exit(1);
        }

        // lettura della dimensione generica dell'intervallo
        try {
            System.out.print("Intervallo generico [1 per unisono, 2 per seconda, ecc.]: ");
            intervalGenericSize = Integer.parseInt(br.readLine());
        } catch (IOException ioe) {
            System.out.println("IO error");
            System.exit(1);
        } catch (NumberFormatException nfe) {
            System.out.println("Valore immesso di tipo non corretto: sono ammessi solo interi");
            System.exit(1);
        }

        // lettura del tipo di intervallo
        try {
            while (!"P".equals(intervalQualifier)
                    && !"m".equals(intervalQualifier) && !"M".equals(intervalQualifier)
                    && !"A".equals(intervalQualifier) && !"d".equals(intervalQualifier)
                    && !"2A".equals(intervalQualifier) && !"2d".equals(intervalQualifier)
                    && !"3A".equals(intervalQualifier) && !"3d".equals(intervalQualifier)
                    && !"4A".equals(intervalQualifier) && !"4d".equals(intervalQualifier)
                    && !"5A".equals(intervalQualifier) && !"5d".equals(intervalQualifier)) {
                System.out.print("Tipo di intervallo [5d, 4d, 3d, 2d, d, m, P, M, A, 2A, 3A, 4A, 5A]: ");
                intervalQualifier = br.readLine();
            }
        } catch (IOException ioe) {
            System.out.println("IO error");
            System.exit(1);
        }

        // strutture dati
        String[][] br_notes = {
            {"C", "C#", "Cx", "Cx#", "Cxx", "Cxx#", "Cxxx", "Cbbbbb", "Cbbbb", "Cbbb", "Cbb", "Cb"},
            {"Dbb", "Db", "D", "D#", "Dx", "Dx#", "Dxx", "Dxx#", "Dxxx", "Dbbbbb", "Dbbbb", "Dbbb"},
            {"Ebbbb", "Ebbb", "Ebb", "Eb", "E", "E#", "Ex", "Ex#", "Exx", "Exx#", "Exxx", "Ebbbbb"},
            {"Fbbbbb", "Fbbbb", "Fbbb", "Fbb", "Fb", "F", "F#", "Fx", "Fx#", "Fxx", "Fxx#", "Fxxx"},
            {"Gxx#", "Gxxx", "Gbbbbb", "Gbbbb", "Gbbb", "Gbb", "Gb", "G", "G#", "Gx", "Gx#", "Gxx"},
            {"Ax#", "Axx", "Axx#", "Axxx", "Abbbbb", "Abbbb", "Abbb", "Abb", "Ab", "A", "A#", "Ax"},
            {"B#", "Bx", "Bx#", "Bxx", "Bxx#", "Bxxx", "Bbbbbb", "Bbbbb", "Bbbb", "Bbb", "Bb", "B"}
        };
        String[][] br_intervals = {
            {"P1", "A1", "2A1", "3A1", "4A1", "5A1", "6A1", "5d1", "4d1", "3d1", "2d1", "d1"},
            {"d2", "m2", "M2", "A2", "2A2", "3A2", "4A2", "5A2", "5d2", "4d2", "3d2", "2d2"},
            {"3d3", "2d3", "d3", "m3", "M3", "A3", "2A3", "3A3", "4A3", "5A3", "5d3", "4d3"},
            {"5d4", "4d4", "3d4", "2d4", "d4", "P4", "A4", "2A4", "3A4", "4A4", "5A4", "6A4"},
            {"5A5", "6A5", "5d5", "4d5", "3d5", "2d5", "d5", "P5", "A5", "2A5", "3A5", "4A5"},
            {"3A6", "4A6", "5A6", "5d6", "4d6", "3d6", "2d6", "d6", "m6", "M6", "A6", "2A6"},
            {"A7", "2A7", "3A7", "4A7", "5A7", "5d7", "4d7", "3d7", "2d7", "d7", "m7", "M7"},};

        // calcolo della rappresentazione binomiale della prima nota
        int nc_start = -1;
        int pc_start = -1;
        String pitch = pitchLetter + pitchAccidental;
        for (int i = 0; i < 7; i++)
            for (int j = 0; j < 12; j++)
                if (br_notes[i][j].equals(pitch)) {
                    nc_start = i;
                    pc_start = j;
                    break;
                }

        // calcolo della rappresentazione binomiale dell'intervallo
        int nc_int = -1;
        int pc_int = -1;
        boolean found = false;
        String interval = intervalQualifier + intervalGenericSize;
        for (int i = 0; i < 7; i++)
            for (int j = 0; j < 12; j++)
                if (br_intervals[i][j].equals(interval)) {
                    nc_int = i;
                    pc_int = j;
                    found = true;
                    break;
                }
        if (!found) {
            System.out.println("L'intervallo " + interval + " non esiste.");
            System.exit(1);
        }

        // calcolo della rappresentazione binomiale della nota finale
        int nc_end = (nc_start + nc_int) % 7;
        int pc_end = (pc_start + pc_int) % 12;

        System.out.println("Risultato: " + br_notes[nc_end][pc_end]);
    }
}
