package Package1;


import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

public class IntervalBuilder2 {

    public static void main(String[] args) {

        // apre lo standard input
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        char pitchLetter = '?';
        String pitchAccidental = null;
        int intervalGenericSize = 0;
        String intervalQualifier = null;

        // lettura del nome della nota base
        try {
            while (pitchLetter != 'A' && pitchLetter != 'B' && pitchLetter != 'C' && pitchLetter != 'D' && pitchLetter != 'E' && pitchLetter != 'F' && pitchLetter != 'G') {
                System.out.print("Inserisci il nome della nota [A..G]: ");
                pitchLetter = br.readLine().toUpperCase().charAt(0);
            }
        } catch (IOException ioe) {
            System.out.println("IO error");
            System.exit(1);
        }

        // lettura dello stato di alterazione della nota base
        try {
            while (!"b".equals(pitchAccidental)
                    && !"#".equals(pitchAccidental) && !"bb".equals(pitchAccidental)
                    && !"x".equals(pitchAccidental) && !"".equals(pitchAccidental)) {
                System.out.print("Inserisci l'eventuale alterazione [bb, b, #, x]: ");
                pitchAccidental = br.readLine().toLowerCase();
            }
        } catch (IOException ioe) {
            System.out.println("IO error");
            System.exit(1);
        }

        // lettura della dimensione generica dell'intervallo
        try {
            System.out.print("Intervallo generico [1 per unisono, 2 per seconda, ecc.]: ");
            intervalGenericSize = Integer.parseInt(br.readLine()) - 1;
        } catch (IOException ioe) {
            System.out.println("IO error");
            System.exit(1);
        } catch (NumberFormatException nfe) {
            System.out.println("Valore immesso di tipo non corretto: sono ammessi solo interi");
            System.exit(1);
        }

        // lettura del tipo di intervallo
        try {
            while (!"P".equals(intervalQualifier)
                    && !"m".equals(intervalQualifier) && !"M".equals(intervalQualifier)
                    && !"A".equals(intervalQualifier) && !"d".equals(intervalQualifier)
                    && !"2A".equals(intervalQualifier) && !"2d".equals(intervalQualifier)
                    && !"3A".equals(intervalQualifier) && !"3d".equals(intervalQualifier)
                    && !"4A".equals(intervalQualifier) && !"4d".equals(intervalQualifier)
                    && !"5A".equals(intervalQualifier) && !"5d".equals(intervalQualifier)) {
                System.out.print("Tipo di intervallo [5d, 4d, 3d, 2d, d, m, P, M, A, 2A, 3A, 4A, 5A]: ");
                intervalQualifier = br.readLine();
            }
        } catch (IOException ioe) {
            System.out.println("IO error");
            System.exit(1);
        }

        // strutture dati
        char[] noteNames = {'C', 'D', 'E', 'F', 'G', 'A', 'B'};
        int[] pcOffsets = {0, 2, 4, 5, 7, 9, 11}; // corrispondenti a: unisono giusto, 2a magg., 3a magg., 4a giusta, 5a giusta, 6a magg., 7a magg.
        String[] noteAccidentals = {"bbbbbbbb", "bbbbbbb", "bbbbbb", "bbbbb", "bbbb", "bbb", "bb", "b", "", "#", "x", "x#", "xx", "xx#", "xxx", "xxx#", "xxxx"};
        String[] intTypes1 = {"5d", "4d", "3d", "2d", "d", "P", "A", "2A", "3A", "4A", "5A"}; // per unisono, quarta e quinta
        String[] intTypes2 = {"5d", "4d", "3d", "2d", "d", "m", "M", "A", "2A", "3A", "4A", "5A"}; // per seconda, terza, sesta e settima

        // calcolo del nome della nota
        int currentNc = 0;
        for (int i = 0; i < noteNames.length; i++)
            if (noteNames[i] == pitchLetter) {
                currentNc = i;
                break;
            }
        int finalNc = (currentNc + intervalGenericSize) % 7;
        if (finalNc < 0)
            finalNc += 7;
        System.out.print("Risultato: " + noteNames[finalNc]);

        // calcolo dello stato di alterazione della nota
        int pcOffset = (pcOffsets[finalNc] - pcOffsets[currentNc]) % 12; // differenza in numero di semitoni tra le due note non alterate   
        if (pcOffset < 0)
            pcOffset += 12;
        int intervalPosition = 0;
        // determino la posizione del tipo di intervallo richiesto all'interno delle strutture dati
        // per un intervallo di prima, quarta o quinta:
        boolean found = false;
        if ((intervalGenericSize % 7) == 0 || (intervalGenericSize % 7) == 3 || (intervalGenericSize % 7) == 4) {
            for (int j = -5; j < 6; j++)
                if (intTypes1[j + 5].equals(intervalQualifier)) {
                    intervalPosition = j;
                    found = true;
                    break;
                }
        } // per un intervallo di seconda, terza, sesta o settima:
        else {
            for (int k = -6; k < 6; k++)
                if (intTypes2[k + 6].equals(intervalQualifier)) {
                    intervalPosition = k;
                    found = true;
                    break;
                }
        }
        if (!found) {
            System.out.println("L'intervallo richiesto non esiste.");
            System.exit(1);
        }

        for (int accidentalIndex = -8; accidentalIndex < 9; accidentalIndex++)
            if (noteAccidentals[accidentalIndex + 8].equals(pitchAccidental)) {
                System.out.println(noteAccidentals[8 + intervalPosition + accidentalIndex]);
                // Siamo certi di non uscire dall'insieme di alterazioni previste [8 bemolli .. 8 diesis]?
                // Gli indici dell'array delle alterazioni variano tra 0 e 16
                // accidentalIndex varia tra -2 e +2 (è l'indice dell'alterazione immessa dall'utente)
                // intervalPosition varia tra -6 e +6
                // Valore minimo per l'indice: 8 - 6 - 2 = 0 >>> OK
                // Valore massimo per l'indice: 8 + 6 + 2 = 16 >>> OK
                break;
            }

    }
}
