package Package1;


import java.io.IOException;
import java.util.List;
import java.util.TreeMap;
import java.util.concurrent.ExecutionException;
import javax.swing.DefaultListModel;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.SwingWorker;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathExpression;
import javax.xml.xpath.XPathExpressionException;
import javax.xml.xpath.XPathFactory;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

public class XPathAnalysisSwing extends javax.swing.JFrame {

    /**
     * Creates new form XPathAnalysisSwing
     */
    public XPathAnalysisSwing() {
        initComponents();
        jListStats.addListSelectionListener(new ListSelectionListener() {
            @Override
            public void valueChanged(ListSelectionEvent e) {
                jLabelSelection.setText("(" + jListStats.getSelectedValue() + ")");
            }
        });
    }
    
    class MaxItem {
        public float floatDuration = 0;
        public int num = 0;
        public int den = 1;
        public Element durationElement;

        private MaxItem() {
            this(0, 1, 0, null);
        }
        
        private MaxItem(Integer n, Integer d, float dur, Element el) {
            num = n;
            den = d;
            floatDuration = dur;
            durationElement = el;
        }
    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        jLabelCurrentFile = new javax.swing.JLabel();
        jButtonOpenFile = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jListStats = new javax.swing.JList<>();
        jLabel2 = new javax.swing.JLabel();
        jLabelSelection = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jLabel1.setText("File corrente: ");

        jLabelCurrentFile.setText("-");

        jButtonOpenFile.setText("Apri file IEEE 1599");
        jButtonOpenFile.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButtonOpenFileActionPerformed(evt);
            }
        });

        jScrollPane1.setViewportView(jListStats);

        jLabel2.setText("Valori ritmici massimi per battuta");

        jLabelSelection.setFont(new java.awt.Font("Lucida Grande", 1, 13)); // NOI18N

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(jButtonOpenFile)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabel1)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jLabelCurrentFile)
                        .addGap(0, 0, Short.MAX_VALUE))
                    .addGroup(layout.createSequentialGroup()
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(layout.createSequentialGroup()
                                .addComponent(jLabel2)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(jLabelSelection)
                                .addGap(0, 0, Short.MAX_VALUE))
                            .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 602, Short.MAX_VALUE))
                        .addContainerGap())))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButtonOpenFile)
                    .addComponent(jLabel1)
                    .addComponent(jLabelCurrentFile))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(jLabelSelection))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 370, Short.MAX_VALUE)
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void jButtonOpenFileActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButtonOpenFileActionPerformed
        JFileChooser chooser = new JFileChooser();
        chooser.setFileFilter(new FileNameExtensionFilter("Documenti IEEE 1599", "xml"));
        if (chooser.showOpenDialog(this) == JFileChooser.APPROVE_OPTION) {
            jLabelCurrentFile.setText(chooser.getSelectedFile().getName());
            jLabelSelection.setText("(calcolo in corso...)");
            jButtonOpenFile.setEnabled(false);
            jListStats.setEnabled(false);
            DefaultListModel<String> listModel = new DefaultListModel();
            jListStats.setModel(listModel);
            SwingWorker worker = new SwingWorker<Boolean, String>() {
                @Override
                public Boolean doInBackground() {
                    try {
                        DocumentBuilderFactory docFactory = DocumentBuilderFactory.newInstance();
                        DocumentBuilder docBuilder = docFactory.newDocumentBuilder();
                        Document myXmlDocument = docBuilder.parse(chooser.getSelectedFile().getPath());

                        XPathFactory myXPathFactory = XPathFactory.newInstance();
                        XPath myXPath = myXPathFactory.newXPath();

                        TreeMap<Integer, MaxItem> maxs = new TreeMap<>();
                        NodeList currentDurations = (NodeList) (myXPath.evaluate("/ieee1599/logic/los/part/measure/voice/chord/duration",
                                myXmlDocument, XPathConstants.NODESET)); // sostituendo chord con * avremmo considerato anche le pause
                        XPathExpression myXPathExpression = myXPath.compile("../../../@number"); // compilazione preventiva: più veloce poi la valutazione
                        for (int i = 0; i < currentDurations.getLength(); i++) {
                            String measure = myXPathExpression.evaluate(currentDurations.item(i));
                            Integer currentMeasure = Integer.parseInt(measure);
                            String currentNumString = ((Element) (currentDurations.item(i))).getAttribute("num");
                            Integer currentNum = Integer.parseInt(currentNumString);
                            String currentDenString = ((Element) (currentDurations.item(i))).getAttribute("den");
                            Integer currentDen = Integer.parseInt(currentDenString);
                            float floatDuration = (float) currentNum / currentDen;
                            if (!maxs.containsKey(currentMeasure) || maxs.get(currentMeasure).floatDuration <= floatDuration)
                                maxs.put(currentMeasure, new MaxItem(currentNum, currentDen, floatDuration, (Element) (currentDurations.item(i))));
                        }
                        for (Integer i : maxs.keySet()) {
                            String s = i + ": " + maxs.get(i).num + "/" + maxs.get(i).den;
                            s += " eseguita da " + myXPath.evaluate("ancestor::part/@id", maxs.get(i).durationElement);
                            publish(s);
                        }
                    } catch (ParserConfigurationException | XPathExpressionException | NumberFormatException | SAXException | IOException ex) {
                        return false;
                    }
                    return true;
                }
                
                @Override
                protected void process(List<String> strs) {
                    for (String s : strs) {
                        listModel.addElement(s);
                    }
                }
                
                @Override
                protected void done() {
                    try {
                        if (!get())
                            JOptionPane.showMessageDialog(null, "Errore nel parsing del file IEEE 1599", "Errore", JOptionPane.ERROR_MESSAGE);
                    } catch (InterruptedException | ExecutionException ex) {
                        JOptionPane.showMessageDialog(null, "Errore nel parsing del file IEEE 1599", "Errore", JOptionPane.ERROR_MESSAGE);
                    }
                    jLabelSelection.setText("");
                    jButtonOpenFile.setEnabled(true);
                    jListStats.setEnabled(true);
                }
            };
            worker.execute();
        }
    }//GEN-LAST:event_jButtonOpenFileActionPerformed

    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        /* Set the Nimbus look and feel */
        //<editor-fold defaultstate="collapsed" desc=" Look and feel setting code (optional) ">
        /* If Nimbus (introduced in Java SE 6) is not available, stay with the default look and feel.
         * For details see http://download.oracle.com/javase/tutorial/uiswing/lookandfeel/plaf.html 
         */
        try {
            for (javax.swing.UIManager.LookAndFeelInfo info : javax.swing.UIManager.getInstalledLookAndFeels())
                if ("Nimbus".equals(info.getName())) {
                    javax.swing.UIManager.setLookAndFeel(info.getClassName());
                    break;
                }
        } catch (ClassNotFoundException ex) {
            java.util.logging.Logger.getLogger(XPathAnalysisSwing.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (InstantiationException ex) {
            java.util.logging.Logger.getLogger(XPathAnalysisSwing.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (IllegalAccessException ex) {
            java.util.logging.Logger.getLogger(XPathAnalysisSwing.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        } catch (javax.swing.UnsupportedLookAndFeelException ex) {
            java.util.logging.Logger.getLogger(XPathAnalysisSwing.class.getName()).log(java.util.logging.Level.SEVERE, null, ex);
        }
        //</editor-fold>

        /* Create and display the form */
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new XPathAnalysisSwing().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButtonOpenFile;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabelCurrentFile;
    private javax.swing.JLabel jLabelSelection;
    private javax.swing.JList<String> jListStats;
    private javax.swing.JScrollPane jScrollPane1;
    // End of variables declaration//GEN-END:variables
}
