package audio;

import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;

public class OpenRawNoEndianness {

    static class RawWaveUtils {

        public static byte[] readStream8bit(File file) throws IOException {
            if (!file.isFile())
                return null;
            InputStream input = new FileInputStream(file);
            int bufferSize = (int) file.length();
            byte[] result = new byte[bufferSize];
            DataInputStream data = new DataInputStream(input);
            for (int i = 0; i < bufferSize; i++) {
                result[i] = data.readByte(); 
            }
            return result;
        }

        public static short[] readStream16bit(File file) throws IOException {
            if (!file.isFile())
                return null;
            InputStream input = new FileInputStream(file);
            int bufferSize = (int) (file.length() / 2);
            // se i campioni sono a 16 bit, l'array deve contenere un numero di elementi pari alla metà della dimensione del file
            short[] result = new short[bufferSize];
            DataInputStream data = new DataInputStream(input);
            for (int i = 0; i < bufferSize; i++) {
                result[i] = data.readShort();
            }
            return result;
        }
    }

    public static void main(String[] args) throws InterruptedException, IOException {
        File fileToOpen = new File("D:/onda_sin_mono_8.raw");
        byte[] byteValues = RawWaveUtils.readStream8bit(fileToOpen);
        // stampa a video
        System.out.println("Onda sinusoidale, 8 bit");
        for (byte value : byteValues) {
            System.out.println(value + " ");
        }
        
        // pausa
        BufferedReader br=new BufferedReader(new InputStreamReader(System.in));
        System.out.println("Premere un tasto per continuare...");
        br.readLine();
        
        fileToOpen = new File("D:/onda_quadra_mono_16.raw");
        short[] shortValues = RawWaveUtils.readStream16bit(fileToOpen);
        // stampa a video
        System.out.println("Onda quadra, 16 bit");
        for (short value : shortValues) {
            System.out.println(value + " ");
        }
        
        // pausa
        System.out.println("Premere un tasto per continuare...");
        br.readLine();
        
        fileToOpen = new File("D:/onda_sin_mono_16.raw");
        shortValues = RawWaveUtils.readStream16bit(fileToOpen);
        // stampa a video
        System.out.println("Onda sinusoidale, 16 bit");
        for (short value : shortValues) {
            System.out.println(value + " ");
        }

    }
}