package jMusic;

import jm.JMC;
import jm.music.data.*;
import jm.util.*;

/**
* b3 c4 d4 e4 f4 g4 a4 b4 c5 d5 e5 f5 g5 a5 b5
* A  E  I  O  U  A  E  I  O  U  A  E  I  O  U
 */
public class GuidoWordMusic implements JMC {

    Phrase phr = new Phrase();
    int[] pitchesA = {b3, g4, e5};
    int[] pitchesE = {c4, a4, f5};
    int[] pitchesI = {d4, b4, g5};
    int[] pitchesO = {e4, c5, a5};
    int[] pitchesU = {f4, d5, b5};
    int consonantCount = 0;
    int prevPitch = c5; // default "starting" pitch

    public static void main(String[] args) {
        if (args.length > 0)
            new GuidoWordMusic(args);
        else
            new GuidoWordMusic("Prova a suonare questa frase".split(" "));
    }

    public GuidoWordMusic(String[] sentence) {
        for (int i = 0; i < sentence.length; i++) {
            for (int j = 0; j < sentence[i].length(); j++) {
                char character = sentence[i].toUpperCase().charAt(j);
                System.out.println(character);
                switch (character) {
                    case 'A':
                        chooseNote(pitchesA);
                        break;
                    case 'E':
                        chooseNote(pitchesE);
                        break;
                    case 'I':
                        chooseNote(pitchesI);
                        break;
                    case 'O':
                        chooseNote(pitchesO);
                        break;
                    case 'U':
                        chooseNote(pitchesU);
                        break;
                    default:
                        consonantCount++;
                        break;
                }
                if (character == 'A' || character == 'E' || character == 'I' || character == 'O' || character == 'U') {
                    System.out.println("** " + character);
                    consonantCount = 0;
                }
            }
        }
        phr.setTempo(120.0);
        View.notate(phr);
        Play.midi(phr);
    }

    private void chooseNote(int[] pitches) {
        int pitch = pitches[(int) (Math.random() * pitches.length)];
        // ensure some voice leading
        while (Math.abs(prevPitch - pitch) > 7) {
            pitch = pitches[(int) (Math.random() * pitches.length)];
        }
        Note n = new Note(pitch, EIGHTH_NOTE * (consonantCount + 1));
        phr.addNote(n);
        prevPitch = pitch;
    }
}


