
package jSyn;

import com.jsyn.JSyn;
import com.jsyn.Synthesizer;
import com.jsyn.devices.AudioDeviceManager;
import com.jsyn.unitgen.LineIn;
import com.jsyn.unitgen.*;

public class PitchDetectorTest {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        new PitchDetectorTest().test();
    }

    private void test() {
        Synthesizer synth;
        UnitOscillator osc1;
        UnitOscillator osc2;
        LineOut lineOut;
        LineIn lineIn;
        PitchDetector pitchDetector;
        Multiply multiply1;
        Multiply multiply2;

        synth = JSyn.createSynthesizer();
        synth.start(44100, AudioDeviceManager.USE_DEFAULT_DEVICE, 2, AudioDeviceManager.USE_DEFAULT_DEVICE, 2);
        synth.add(lineIn = new LineIn());
        synth.add(lineOut = new LineOut());
        synth.add(pitchDetector = new PitchDetector());
        synth.add(osc1 = new SineOscillator());
        synth.add(osc2 = new SineOscillator());
        synth.add(multiply1 = new Multiply());
        synth.add(multiply2 = new Multiply());
        
        lineIn.output.connect(pitchDetector.input);
        pitchDetector.confidence.connect(osc1.amplitude);
        pitchDetector.confidence.connect(osc2.amplitude);
        
        multiply1.inputA.set(0.5);
        pitchDetector.frequency.connect(multiply1.inputB);
        multiply1.output.connect(osc1.frequency);

        multiply2.inputA.set(2);
        pitchDetector.frequency.connect(multiply2.inputB);
        multiply2.output.connect(osc2.frequency);
        
        osc1.output.connect(0, lineOut.input, 0);
        osc2.output.connect(0, lineOut.input, 1);

        lineOut.start();
    }
    
}
